;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Redefinitions and Custumizations of AUC-TeX for gold.el !           ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
(gold-debug "gold_auctex")
;;----------------------------------------------------------------------------
(require 'tex-site) ;; This statement should be in standard init file already !
;;----------------------------------------------------------------------------
;;(local-set-key "\t" 'TeX-complete-symbol)
(local-set-key "\t" 'tab-left-right)
(substitute-key-definition 'show-next-error 'TeX-next-error
                           (current-local-map) global-map)
(substitute-key-definition 'next-error 'TeX-next-error
                           (current-local-map) global-map)
;;----------------------------------------------------------------------------
(setq compile-buffer-function 'TeX-command-master)
(setq TeX-region (concat "_#" (user-login-name)))
;;----------------------------------------------------------------------------
(defvar LaTeX-document-regexp "\\(document\\|DOC\\)")
(defvar LaTeX-begin-regexp    "\\(begin\\|B\\)")
(defvar LaTeX-end-regexp      "\\(end\\|E\\)")
;;
;?(setq LaTeX-header-end (concat (regexp-quote TeX-esc)
;?      LaTeX-begin-regexp " *" TeX-grop LaTeX-document-regexp TeX-grcl))
;?;;
;?(setq LaTeX-trailer-start (concat (regexp-quote TeX-esc)
;?      LaTeX-end-regexp " *" TeX-grop LaTeX-document-regexp TeX-grcl))
;;
;;-------------------------
(defvar LaTeX-begin "begin" "*String used for \\\"begin\"{...} environment.")
(defvar LaTeX-end   "end"   "*String used for \\\"end\"{...} environment.")
;;
(setq LaTeX-begin "B")
(setq LaTeX-end   "E")
;;
;?(defun LaTeX-insert-environment (environment &optional extra)
;?  "Insert environment of type ENV, with optional argument EXTRA."
;?  (if (and (TeX-active-mark)
;?           (not (eq (mark) (point))))
;?      (progn
;?        (if (< (mark) (point))
;?            (exchange-point-and-mark))
;?        (or (TeX-looking-at-backward "^[ \t]*")
;?            (newline))
;?        (insert TeX-esc LaTeX-begin TeX-grop environment TeX-grcl)
;?        (LaTeX-indent-line)
;?        (if extra (insert extra))
;?        (newline)
;?        (goto-char (mark))
;?        (or (TeX-looking-at-backward "^[ \t]*")
;?            (newline))
;?        (insert TeX-esc LaTeX-end TeX-grop environment TeX-grcl)
;?        (or (looking-at "[ \t]*$")
;?            (save-excursion (newline-and-indent)))
;?        (LaTeX-indent-line)
;?        (end-of-line 0)
;?        (or (assoc environment LaTeX-indent-environment-list)
;?            (LaTeX-fill-environment nil)))
;?    (or (TeX-looking-at-backward "^[ \t]*")
;?        (newline))
;?    (insert TeX-esc LaTeX-begin TeX-grop environment TeX-grcl)
;?    (LaTeX-indent-line)
;?    (if extra (insert extra))
;?    (newline-and-indent)
;?    (newline)
;?    (insert TeX-esc LaTeX-end TeX-grop environment TeX-grcl)
;?    (or (looking-at "[ \t]*$")
;?        (save-excursion (newline-and-indent)))
;?    (LaTeX-indent-line)
;?    (end-of-line 0)))
;;
;;----------------------------------------------------------------------------
(setq TeX-command-list
  ;; You may have to remove the single quotes around the command
  ;; arguments if you use DOS.
  (list (list "TeX" "tex '\\nonstopmode\\input %t'" 'TeX-run-TeX nil t)
        (list "TeX Interactive" "tex %t" 'TeX-run-interactive nil t)
        (list "LaTeXe" "%le -quiet %t" 'TeX-run-LaTeX nil t)
        (list "LaTeXg" "%lg -quiet %t" 'TeX-run-LaTeX nil t)
        (list "LaTeXf" "%lf -quiet %t" 'TeX-run-LaTeX nil t)
        (list "LaTeXs" "%ls -quiet %t" 'TeX-run-LaTeX nil t)
        (list "LaTeX_Interactive" "%l %t" 'TeX-run-interactive nil t)
        (list "LaTeXg_Interactive" "%lg %t" 'TeX-run-interactive nil t)
        (list "LaTeXf_Interactive" "%lf %t" 'TeX-run-interactive nil t)
        (list "LaTeXs_Interactive" "%ls %t" 'TeX-run-interactive nil t)
        (list "All"   "%le -quiet %t; dvips1 %s" 'TeX-run-LaTeX nil t)
        (list "Allg" "%lg -quiet %t; dvips1 %s" 'TeX-run-LaTeX nil t)
        (list   "Dvips"   "dvips %d -o%f -p1" 'TeX-run-command t nil)
        (list "L:Dvips&letter" "dvips -p1 %s; printletter %s" 'TeX-run-command t nil)
        (list "1:Dvips&print" "dvips -p1 %s; print -1 %s" 'TeX-run-command t nil)
        (list "2:Dvips&print" "dvips -p1 %s; print -2 %s" 'TeX-run-command t nil)
        (list "3:Dvips&print" "dvips -p1 %s; print -3 %s" 'TeX-run-command t nil)
        (list "4:Dvips&print" "dvips -p1 %s; print -4 %s" 'TeX-run-command t nil)
        (list "5:Dvips&print" "dvips -p1 %s; print -5 %s" 'TeX-run-command t nil)
        (if (or window-system (getenv "DISPLAY"))
            (list "View" "kdvi %d" 'TeX-run-background t nil)
          (list "View" "dvi2tty -q -w 132 %s " 'TeX-run-command t nil))
        (list "Print" "%p " 'TeX-run-command t nil)
        (list "Queue" "%q" 'TeX-run-background nil nil)
        (list "File" "dvips %d -o %f " 'TeX-run-command t nil)
        (list "BibTeX" "bibtex %s" 'TeX-run-BibTeX nil nil)
        (list "Index" "makeindex %s" 'TeX-run-command nil t)
        (list "Check" "lacheck %s" 'TeX-run-compile nil t)
        (list "Spell" "<ignored>" 'TeX-run-ispell nil nil)
        (list "Other" "" 'TeX-run-command t t)
        ;; Not part of standard TeX.
        (list "Makeinfo" "makeinfo %t" 'TeX-run-compile nil t))
)
;;----------------------------------------------------------------------------
(provide 'gold_auctex)
