;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein INTES
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Additional bugfixes for standard emacs lisp-files (to be removed).  ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
;;
;; bug-fix for subr.el:
;;----------------------
(defun momentary-string-display (string pos &optional exit-char message)
  "Momentarily display STRING in the buffer at POS.
Display remains until next event is input.
If POS is a marker, only its position is used; its buffer is ignored.
Optional third arg EXIT-CHAR can be a character, event or event
description list.  EXIT-CHAR defaults to SPC.  If the input is
EXIT-CHAR it is swallowed; otherwise it is then available as
input (as a command if nothing else).
Display MESSAGE (optional fourth arg) in the echo area.
If MESSAGE is nil, instructions to type EXIT-CHAR are displayed there."
  (or exit-char (setq exit-char ?\s))
  (let ((ol (make-overlay pos pos)))
;;>>> removed
;;        (message (copy-sequence string)))
;;>>> removed
    (unwind-protect
        (progn
          (save-excursion
            (overlay-put ol 'after-string string)
            (goto-char pos)
            ;; To avoid trouble with out-of-bounds position
            (setq pos (point))
            ;; If the message end is off screen, recenter now.
            (if (<= (window-end nil t) pos)
                (recenter (/ (window-height) 2))))
          (message (or message "Type %s to continue editing.")
                   (single-key-description exit-char))
          (let (char)
            (if (integerp exit-char)
                (condition-case nil
                    (progn
                      (setq char (read-char))
                      (or (eq char exit-char)
                          (setq unread-command-events (list char))))
                  (error
                   ;; `exit-char' is a character, hence it differs
                   ;; from char, which is an event.
                   (setq unread-command-events (list char))))
              ;; `exit-char' can be an event, or an event description list.
              (setq char (read-event))
              (or (eq char exit-char)
                  (eq char (event-convert-list exit-char))
                  (setq unread-command-events (list char))))))
      (delete-overlay ol))))
;;
;;----------------------------------------------------------------------------
(provide 'gold_bugfix)
