;;; This file is an addition to the GNU Emacs. GNU Emacs and the herein GOLD
;;; additions are distributed in the hope that it will be useful, but without
;;; ANY WARRANTY.  No author or distributor accepts responsibility to anyone
;;; for the consequences of using it or for whether it serves any particular
;;; purpose or works at all, unless he says so in writing.
;;; Everyone is granted permission to copy, modify and redistribute GNU Emacs,
;;; but only under the conditions described in the GNU Emacs General Public Li-
;;; cense.   A copy of this license is supposed to have been given to you along
;;; with GNU Emacs so you can know your rights and responsibilities.  It should
;;; be in a file named COPYING.  Among other things, the copyright notice and
;;; this notice must be preserved on all copies.
;;; Refer to the GNU Emacs General Public License for full details.
;;;
;;;############################################################################
;;;###  Standard GOLD Key-Bindings based on code for VT200/320-Terminals !  ###
;;;###  This file is included (direct- or auto-loaded) by the main entry    ###
;;;###  file >>> gold.el <<< => Refer to that file for more informations.   ###
;;;############################################################################
;;; Bug reports and suggestions are always welcome !
;;
(gold-debug "gold_keyboard ")

;; Redefine some function-keynames:
;;----------------------------------
(defun remap-function-keys () (interactive)
  (global-unset-key  [kp-f1])  ; Free Esc binding
  (define-key function-key-map [kp-f1]      [gold])
;
;  (define-key function-key-map [t]  [gold])
;  (define-key function-key-map [num-lock]   [gold])
  (define-key function-key-map [numlock]    [gold])
  (define-key function-key-map [kp-numlock] [gold])
;
;?(define-key function-key-map [kp-separator] [kp-decimal])
  (define-key global-map       [kp-delete]  [kp-decimal])
  (define-key function-key-map [kp-delete]  [kp-decimal])
  (define-key function-key-map [kp-insert]  [kp-0])
  (define-key function-key-map [kp-end]     [kp-1])
  (define-key function-key-map [kp-down]    [kp-2])
  (define-key function-key-map [kp-next]    [kp-3])
  (define-key function-key-map [kp-left]    [kp-4])
  (define-key function-key-map [kp-begin]   [kp-5])
  (define-key function-key-map [kp-right]   [kp-6])
  (define-key function-key-map [kp-home]    [kp-7])
  (define-key function-key-map [kp-up]      [kp-8])
  (define-key function-key-map [kp-prior]   [kp-9])
  (define-key function-key-map [system]     [gold])
  (define-key function-key-map [user]       [gold])
  (define-key function-key-map "\eOP"       [gold])
  (define-key function-key-map "\eOA"       [up])
  (define-key function-key-map "\eOB"       [down])
  (define-key function-key-map "\eOC"       [right])
  (define-key function-key-map "\eOD"       [left])
  (define-key function-key-map [apps]       [gold]) ; Windows95/98/NT
  ;; Make the vt200-Esc-key sending F11 (rather than escape key):
  (if (not x-terminal) (define-key function-key-map "\e[23~" [f11]))
)
;(setq system-key-alist '((65280 . remove)(65407 . kp-1)))
;(setq test (recent-keys))
;(setq test (read-event))


;;****************************************************************************
;;***** Make GOLD-map and bind it to all possible 'GOLD-map' keys !   ********
;;****************************************************************************
(define-prefix-command 'GOLD-map)
(global-set-key [gold] 'GOLD-map)
;;
(defun define-GOLD-local (local-map key symbol)
  "Function for local redefinition of GOLD-keys (using local keymap only)."
  (define-key local-map (vconcat '(gold) key) symbol))

;;****************************************************************************
;;***** Default Key bindings (vt100/200/300) ! *******************************
;;****************************************************************************

;; ESC Keypad keys (Spezialtrick zum Umgehen der EscEsc-Standard-Funktion):
;; -------------------------------------------------------------------------
(define-key esc-map [up]    'line-to-top-of-window)   ; ESC  <Up>
(define-key esc-map [down]  'line-to-bottom-of-window); ESC  <Down>
(define-key esc-map [right] 'delete-to-eol)           ; ESC  <Right>
(define-key esc-map [left]  'delete-to-sol)           ; ESC  <Left>
(define-key esc-map " "     'just-one-space)          ; ESC  <Space>
;;
;; 7bit-Alternatives
(define-key esc-map    "\e" 'EscEsc-prefix)           ; ESC  ESC
(defvar EscEsc-map (make-keymap) "?")
(fset 'EscEsc-prefix EscEsc-map)
;;
;; Do not interpret AltGrp as special event on german keyboards
(global-set-key [key-3] 'ignore-event)
(define-key isearch-mode-map [key-3] 'ignore-event)


;; GOLD Keyboard keys:
;; -------------------
(define-key GOLD-map "\177" 'delete-window)           ; Gold <Delete>
(define-key GOLD-map "\C-h" 'delete-other-windows)    ; Gold <BackSp>
(define-key GOLD-map "\C-m" 'switch-shell)            ; Gold <Return>
(define-key GOLD-map " "    'speedbar)                ; Gold <Space>
(define-key GOLD-map "\""   'alt-umlaut-mode)         ; Gold <">
(define-key GOLD-map "'"    'alt-aigu-mode)           ; Gold <'>
(define-key GOLD-map "^"    'alt-circumflex-mode)     ; Gold <^>
(define-key GOLD-map "`"    'alt-grave-mode)          ; Gold <`>
(define-key GOLD-map "~"    'alt-tilde-mode)          ; Gold <~>
(define-key GOLD-map "|"    'alt-bar-mode)            ; Gold <|>
(define-key GOLD-map "/"    'alt-slash-mode)          ; Gold <\>
(define-key GOLD-map ","    'alt-cedilla-mode)        ; Gold <\>
(define-key GOLD-map "&"    'application-keys-on)     ; Gold <&>
(define-key GOLD-map "?"    'what-position)           ; Gold <?>
(define-key GOLD-map "!"    'what-cursor-position)    ; Gold <!>
(define-key GOLD-map "@"    'Lisp-byte-compile)       ; Gold <@>
;define-key GOLD-map "#"    'eval-buffer-or-region)   ; Gold <#>
(define-key GOLD-map "#"    'eval-current-buffer)     ; Gold <#>
(define-key GOLD-map "%"    'goto-percent)            ; Gold <%>
(define-key GOLD-map "*"    're-find-file)            ; Gold <*>
(define-key GOLD-map "="    'goto-line)               ; Gold <=>
(define-key GOLD-map "_"    'goto-column)             ; Gold <_>
(define-key GOLD-map "\t"   'context-indent)          ; Gold <Tab>
(define-key GOLD-map "["    'show-open-bracket)       ; Gold <[>
(define-key GOLD-map "]"    'show-close-bracket)      ; Gold <]>
(define-key GOLD-map "."    'jump-mark)               ; Gold <.>
(define-key GOLD-map ";"    'edit-dir-title-file)     ; Gold <;>
(define-key GOLD-map "$"    'test-buffer-parentheses) ; Gold <$>
(define-key GOLD-map "\\"   'preview-buffer)          ; Gold <\>
(define-key GOLD-map "("    'start-kbd-macro)         ; Gold <(>
(define-key GOLD-map ")"    'end-kbd-macro)           ; Gold <(>
(define-key GOLD-map "-"    'digit-argument)          ; Gold <->
(define-key GOLD-map "+"    'digit-argument)          ; Gold <+>
(define-key GOLD-map "1"    'digit-argument)          ; Gold <1>
(define-key GOLD-map "2"    'digit-argument)          ; Gold <2>
(define-key GOLD-map "3"    'digit-argument)          ; Gold <3>
(define-key GOLD-map "4"    'digit-argument)          ; Gold <4>
(define-key GOLD-map "5"    'digit-argument)          ; Gold <5>
(define-key GOLD-map "6"    'digit-argument)          ; Gold <6>
(define-key GOLD-map "7"    'digit-argument)          ; Gold <7>
(define-key GOLD-map "8"    'digit-argument)          ; Gold <8>
(define-key GOLD-map "9"    'digit-argument)          ; Gold <9>
(define-key GOLD-map "0"    'digit-argument)          ; Gold <0>
(define-key GOLD-map ">"    'narrow)                  ; Gold <>>
(define-key GOLD-map "<"    'widen)                   ; Gold <<>

;; GOLD Letter keys:
;; -----------------
; Gold-C will become (context-dependend) compile-buffer (e.g. Lisp/F77/TeX).
(define-key GOLD-map "a"    'abbrev-mode)             ; Gold <a>
(define-key GOLD-map "A"    'abbrev-mode)             ; Gold <A>
(define-key GOLD-map "b"    'GOLD-buffer-menu)       ; Gold <b>
(define-key GOLD-map "B"    'GOLD-buffer-menu)       ; Gold <B>
(define-key GOLD-map "c"    'quick-calc)              ; Gold <c>
(define-key GOLD-map "C"    'quick-calc)              ; Gold <C>
(define-key GOLD-map "d"    'show-document)           ; Gold <d>
(define-key GOLD-map "D"    'show-document)           ; Gold <D>
(define-key GOLD-map "e"    'call-kbd-macro)          ; Gold <e>
(define-key GOLD-map "E"    'call-kbd-macro)          ; Gold <E>
(define-key GOLD-map "f"    'find-file)               ; Gold <f>
(define-key GOLD-map "F"    'find-file)               ; Gold <F>
(define-key GOLD-map "h"    'split-window-vertically) ; Gold <h>
(define-key GOLD-map "H"    'split-window-vertically) ; Gold <H>
(define-key GOLD-map "i"    'insert-file)             ; Gold <i>
(define-key GOLD-map "I"    'insert-file)             ; Gold <I>
(define-key GOLD-map "j"    'insert-buffer)           ; Gold <i>
(define-key GOLD-map "J"    'insert-buffer)           ; Gold <I>
(define-key GOLD-map "k"    'kill-a-buffer)           ; Gold <k>
(define-key GOLD-map "K"    'kill-a-buffer)           ; Gold <K>
(define-key GOLD-map "l"    'find-alternate-file)     ; Gold <l>
(define-key GOLD-map "L"    'find-alternate-file)     ; Gold <L>
(define-key GOLD-map "n"    'next-buffer)             ; Gold <n>
(define-key GOLD-map "N"    'next-buffer)             ; Gold <N>
(define-key GOLD-map "o"    'revert-buffer)           ; Gold <o>
(define-key GOLD-map "O"    'revert-buffer)           ; Gold <O>
(define-key GOLD-map "p"    'append-paste-to-file)    ; Gold <p>
(define-key GOLD-map "P"    'append-paste-to-file)    ; Gold <P>
(define-key GOLD-map "q"    'save-buffers-kill-emacs) ; Gold <q>
(define-key GOLD-map "Q"    'save-buffers-kill-emacs) ; Gold <Q>
(define-key GOLD-map "r"    'recover-file)            ; Gold <r>
(define-key GOLD-map "R"    'recover-file)            ; Gold <R>
(define-key GOLD-map "s"    'save-buffer)             ; Gold <s>
(define-key GOLD-map "S"    'save-buffer)             ; Gold <S>
(define-key GOLD-map "t"    'cut-trailing-blanks)     ; Gold <t>
(define-key GOLD-map "T"    'cut-trailing-blanks)     ; Gold <T>
(define-key GOLD-map "v"    'split-window-horizontally);Gold <v>
(define-key GOLD-map "V"    'split-window-horizontally);Gold <V>
(define-key GOLD-map "w"    'write-file)              ; Gold <w>
(define-key GOLD-map "W"    'write-file)              ; Gold <W>
(define-key GOLD-map "y"    'enlarge-window)          ; Gold <y>
(define-key GOLD-map "Y"    'enlarge-window)          ; Gold <Y>
(define-key GOLD-map "x"    'split-screen)            ; Gold <x>
(define-key GOLD-map "X"    'split-screen)            ; Gold <X>
(define-key GOLD-map "z"    'shrink-window)           ; Gold <z>
(define-key GOLD-map "Z"    'shrink-window)           ; Gold <Z>

;; Unmodified Keypad keys:                                   ;
;; -----------------------                                   ;
(global-set-key [kp-f1]            'GOLD-map)                ;      <PF1>
(global-set-key [kp-f2]            'GOLD-help)               ;      <PF2>
(global-set-key [kp-f3]            'isearch-back-forward)    ;      <PF3>
(global-set-key [kp-f4]            'delete-current-line)     ;      <PF4>
(global-set-key [kp-0]             'UNDO)                    ;      <"0">
(global-set-key [kp-1]             'word-back-forward)       ;      <"1">
(global-set-key [kp-2]             'insert-paste)            ;      <"2">
(global-set-key [kp-3]             'main-buffer)             ;      <"3">
(global-set-key [kp-4]             'bookmark-jump)           ;      <"4">
(global-set-key [kp-5]             'copy-to-paste)           ;      <"5">
(global-set-key [kp-6]             'case-flip-left-right)    ;      <"6">
(global-set-key [kp-7]             'toggle-direction)        ;      <"7">
(global-set-key [kp-8]             'mark-paste)              ;      <"8">
(global-set-key [kp-9]             'repeat-search)           ;      <"9">
(global-set-key [kp-subtract]      'delete-current-word)     ;      <",">
(global-set-key [kp-separator]     'delete-current-char)     ;      <",">
(global-set-key [kp-period]        'redraw-display-h)        ;      <".">
(global-set-key [kp-enter]         'new-line)                ;      <Enter>
;;
;; Clear KP-Keys from I-Search-Map (make it invoke the kp-functions)
(define-key isearch-mode-map [delete] 'isearch-delete-char)
(define-key isearch-mode-map [kp-1] nil)
(define-key isearch-mode-map [kp-2] nil)
(define-key isearch-mode-map [kp-3] nil)
(define-key isearch-mode-map [kp-4] nil)
(define-key isearch-mode-map [kp-5] nil)
(define-key isearch-mode-map [kp-6] nil)
(define-key isearch-mode-map [kp-7] nil)
(define-key isearch-mode-map [kp-8] nil)
(define-key isearch-mode-map [kp-9] nil)
(define-key isearch-mode-map [kp-f3]       'isearch-other-meta-char)
(define-key isearch-mode-map [kp-multiply] 'isearch-other-meta-char)
(define-key isearch-mode-map [find]        'isearch-other-meta-char)
(define-key isearch-mode-map [menu]        'isearch-other-meta-char)
(define-key isearch-mode-map [f8]          'isearch-other-meta-char)
;;
;; Cursor&Scroll-Block etc.
(global-set-key [up]               'previous-line-h)         ;      <Up>
(global-set-key [down]             'next-line-h)             ;      <Down>
(global-set-key [right]            'forward-char-h)          ;      <Right>
(global-set-key [left]             'backward-char-h)         ;      <Left>
(global-set-key [prior]            'scroll-down-h)           ;      <PrevScreen>
(global-set-key [next]             'scroll-up-h)             ;      <NextScreen>
(global-set-key [find]             'isearch-back-forward)    ;      <Find>
(global-set-key [insert]           'overwrite-mode)          ;      <Insert>
(global-set-key [insertchar]       'overwrite-mode)          ;      <Insert>
(global-set-key [delete]           'delete-current-char)     ;      <Delete>
(global-set-key [deletechar]       'delete-current-char)     ;      <Remove>
(global-set-key [dremove]          'delete-current-char)     ;      <Remove>
(global-set-key [remove]           'delete-current-char)     ;      <Remove>
(global-set-key [select]           'GOLD-buffer-menu)        ;      <Select>
(global-set-key [menu]             'call-kbd-macro)          ;      <Do/Menu>
(global-set-key [help]             'context-help)            ;      <Help>
(global-set-key [Scroll_Lock]      'compile-buffer)          ;      <ScrollLock>
(global-set-key [key-20]           'compile-buffer)          ;      <ScrollLock>
;;
;; Numbered function keys
(global-set-key [f6]               'find-tag-h)              ; F6
(global-set-key [f7]               'repeat-tag-search)       ; F7
(global-set-key [f8]               'compare-windows)         ; F8
(global-set-key [f9]               'quick-calc)              ; F9
(global-set-key [f10]              'prt-region)              ; F10
(global-set-key [f11]              'show-next-error)         ; F11
(global-set-key [f12]              'comment-region)          ; F12 -> BackSpace
(global-set-key [f13]              'split-line)              ; F13 -> LineFeed
(global-set-key [f14]              'newline-and-indent)      ; F14
(global-set-key [f15]              'context-help)            ; F15 -> Help
(global-set-key [f16]              'call-kbd-macro)          ; F16 -> Menu(Do)
(global-set-key [f17]              'start/end-kbd-macro)     ; F17
(global-set-key [f18]              'ispell-word)             ; F18
(global-set-key [f19]              'translate-word)          ; F19
(global-set-key [f20]              'multiply-current-line)   ; F20
;;
;; Shift Function-Keys F17-F20 to F1-F5 for WYSE
(define-key global-map [f1]        (key-binding [f17]))
(define-key global-map [f2]        (key-binding [f18]))
(define-key global-map [f3]        (key-binding [f19]))
(define-key global-map [f4]        (key-binding [f20]))
(define-key global-map [f5]        (key-binding [select]))
;;
;; Set Function-Keys F25,F26,F24 on Numeric Keypad for strange SUN-PC
(define-key global-map [f25]        (key-binding [kp-f2]))
(define-key global-map [f26]        (key-binding [kp-f3]))
(define-key global-map [f24]        (key-binding [kp-f4]))
;;
; Additional/Alternate keys (default for dubious terminals):
(global-set-key [pause]            (key-binding [help]))     ;      Help
(global-set-key [print]            'prt-region)              ;      <Print>
(global-set-key [kp-divide]        (key-binding [kp-f2]))    ;      <PF2>
(global-set-key [kp-multiply]      (key-binding [kp-f3]))    ;      <PF3>
(global-set-key [home]             'line-to-top-of-window)   ;      <Home>
(global-set-key [end]              'line-to-bottom-of-window);      <End>
(global-set-key [kp-decimal]       'redraw-display-h)        ;      <".">
(global-set-key [break]            'keyboard-quit)           ;      =\C-g
(global-set-key [stop]             'keyboard-quit)           ;      =\C-g


;; GOLD Keypad keys:                                            ;
;; -----------------                                            ;
(define-key GOLD-map [gold]        'execute-extended-command); Gold <Gold>
(define-key GOLD-map [kp-f1]       'execute-extended-command); Gold <Gold>
(define-key GOLD-map [kp-f2]       'set-variable)            ; Gold <PF2>
(define-key GOLD-map [kp-f3]       're-search-back-forward)  ; Gold <PF3>
(define-key GOLD-map [kp-f4]       'undelete-lines)          ; Gold <PF4>
(define-key GOLD-map [kp-0]        'overwrite-mode)          ; Gold <"0">
(define-key GOLD-map [kp-1]        'edit-bookmarks)          ; Gold <"1">
(define-key GOLD-map [kp-2]        'append-paste-to-buffer)  ; Gold <"2">
(define-key GOLD-map [kp-3]        'delete-window)           ; Gold <"3">
(define-key GOLD-map [kp-4]        'bookmark-set)            ; Gold <"4">
(define-key GOLD-map [kp-5]        'cut-to-paste)            ; Gold <"5">
(define-key GOLD-map [kp-6]        'query-replace-regexp)    ; Gold <"6">
(define-key GOLD-map [kp-7]        'toggle-truncate)         ; Gold <"7">
(define-key GOLD-map [kp-8]        'mark-paste-column)       ; Gold <"8">
(define-key GOLD-map [kp-9]        'all-occur)               ; Gold <"9">
(define-key GOLD-map [kp-subtract] 'undelete-words)          ; Gold <"-">
(define-key GOLD-map [kp-separator]'undelete-chars)          ; Gold <",">
(define-key GOLD-map [kp-period]   'global-font-lock-mode)   ; Gold <".">
(define-key GOLD-map [kp-enter]    'other-window)            ; Gold <Enter>
;;
(define-key GOLD-map [up]          'move-to-beginning)       ; Gold <Up>
(define-key GOLD-map [down]        'move-to-end)             ; Gold <Down>
(define-key GOLD-map [right]       'end-of-line)             ; Gold <Right>
(define-key GOLD-map [left]        'beginning-of-line)       ; Gold <Left>
(define-key GOLD-map [prior]       'beginning-of-context)    ; Gold-PrevScreen
(define-key GOLD-map [next]        'end-of-context)          ; Gold-NextScreen
(define-key GOLD-map [find]        're-search-back-forward)  ; Gold-Find
(define-key GOLD-map [insert]      'toggle-read-only)        ; Gold-Insert
(define-key GOLD-map [insertchar]  'toggle-read-only)        ; Gold-Insert
(define-key GOLD-map [delete]      'cut-context-to-paste)    ; Gold-Remove
(define-key GOLD-map [deletechar]  'cut-context-to-paste)    ; Gold-Remove
(define-key GOLD-map [select]      'mark&copy-context)       ; Gold-Select
(define-key GOLD-map [menu]        'save-kbd-macro)          ; Gold-Menu
(define-key GOLD-map [help]        'context-update)          ; Gold-Help
(define-key GOLD-map [Scroll_Lock] 'context-work)            ; Gold-ScrollLock
(define-key GOLD-map [key-20]      'context-work)            ; Gold-ScrollLock
;;
(define-key GOLD-map [f6]          'tags-search-h)           ; Gold-F6
(define-key GOLD-map [f7]          'visit-tags-table)        ; Gold-F7
(define-key GOLD-map [f8]          'ediff-buffers)           ; Gold-F8
(define-key GOLD-map [f9]          'integer-display-key)     ; Gold-F9
(define-key GOLD-map [f10]         'prt-buffer)              ; Gold-F10
(define-key GOLD-map [f11]         'compile-buffer)          ; Gold-F11 (Esc)
(define-key GOLD-map [f12]         'uncomment-region)        ; Gold-F12
(define-key GOLD-map [f13]         'combine-lines)           ; Gold-F13
(define-key GOLD-map [f14]         'join-line)               ; Gold-F14
(define-key GOLD-map [f15]         'context-update)          ; Gold-F15
(define-key GOLD-map [f16]         'save-kbd-macro)          ; Gold-F16
(define-key GOLD-map [f17]         'name-last-kbd-macro)     ; Gold-F17
(define-key GOLD-map [f18]         'ispell-complete-word)    ; Gold-F18
(define-key GOLD-map [f19]         'ispell-change-dictionary); Gold-F19
(define-key GOLD-map [f20]         'glue-cursor)             ; Gold-F20
;; Shift Function-Keys F17-F20 to F1-F5 for WYSE
(define-key GOLD-map [f1]          (key-binding [gold f17]))
(define-key GOLD-map [f2]          (key-binding [gold f18]))
(define-key GOLD-map [f3]          (key-binding [gold f19]))
(define-key GOLD-map [f4]          (key-binding [gold f20]))
(define-key GOLD-map [f5]          (key-binding [gold select]))
;
; Additional/Alternate keys (default for dubious terminals):
(define-key GOLD-map [pause]       (key-binding [gold help])) ; Gold-Help
(define-key GOLD-map [print]       'prt-buffer)               ; Gold-<Print>
(define-key GOLD-map [kp-divide]   (key-binding [gold kp-f2])); Gold-<PF2>
(define-key GOLD-map [kp-multiply] (key-binding [gold kp-f3])); Gold-<PF3>
(define-key GOLD-map [home]        'mark&copy-context)        ; Gold-Select
(define-key GOLD-map [end]         'cut-context-to-paste)     ; Gold-Remove
(define-key GOLD-map [kp-decimal]  'global-font-lock-mode)    ; Gold <".">
(define-key GOLD-map [break]       (key-binding [gold Q]))    ; =Gold-Quit
(define-key GOLD-map [stop]        (key-binding [gold Q]))    ; =Gold-Quit


;;; Shifted keys (where available):
;;;--------------------------------
(global-set-key [(shift up)]       'scroll-half-down)        ; Shift<Up>
(global-set-key [(shift down)]     'scroll-half-up)          ; Shift<Down>
(global-set-key [(shift right)]    'forward-word)            ; Shift<Right>
(global-set-key [(shift left)]     'backward-word)           ; Shift<Left>


;; Alternative Numeric keys:
;; --------------------------                                ;
;(global-set-key [S-kp-f1]          'GOLD-map)                ;      <PF1>
;(global-set-key [S-kp-f2]          'GOLD-help)               ;      <PF2>
;(global-set-key [S-kp-f3]          'isearch-back-forward)    ;      <PF3>
;(global-set-key [S-kp-f4]          'delete-current-line)     ;      <PF4>
(global-set-key [S-kp-0]           "0")                      ;      <"0">
(global-set-key [S-kp-1]           "1")                      ;      <"1">
(global-set-key [S-kp-2]           "2")                      ;      <"2">
(global-set-key [S-kp-3]           "3")                      ;      <"3">
(global-set-key [S-kp-4]           "4")                      ;      <"4">
(global-set-key [S-kp-5]           "5")                      ;      <"5">
(global-set-key [S-kp-6]           "6")                      ;      <"6">
(global-set-key [S-kp-7]           "7")                      ;      <"7">
(global-set-key [S-kp-8]           "8")                      ;      <"8">
(global-set-key [S-kp-9]           "9")                      ;      <"9">
(global-set-key [S-kp-divide]      "/")                      ;      <"/">
(global-set-key [S-kp-multiply]    "*")                      ;      <"*">
(global-set-key [S-kp-subtract]    "-")                      ;      <"-">
(global-set-key [S-kp-add]         "+")                      ;      <"+">
(global-set-key [S-kp-separator]   ",")                      ;      <",">
(global-set-key [S-kp-period]      ".")                      ;      <".">
(global-set-key [S-kp-decimal]     ".")                      ;      <".">
(global-set-key [S-kp-delete]      ".")                      ;      <".">
;(global-set-key [S-kp-enter]       (key-binding "C-m"))


;;; Additional/Alternative-Keys for PC-VT100:
;;;-------------------------------------------
(if (and REMOTEHOST (string-match "^pc-" REMOTEHOST))
    (cond
    ((or (string-match "^pc-1" REMOTEHOST)
         (string-match "^pc-2" REMOTEHOST)
         (string-match "^pc-3" REMOTEHOST))
     (define-key  esc-map "1"        (key-binding [insertchar]))
     (define-key  esc-map "M"        (key-binding [prior]))
     (define-key  esc-map "D"        (key-binding [next]))
     (define-key  esc-map "[H"       'line-to-top-of-window)
     (define-key  esc-map "[24;1H"   (key-binding [select]))
     (define-key GOLD-map "\e1"      (key-binding [gold insertchar]))
     (define-key GOLD-map "\eM"      (key-binding [gold prior]))
     (define-key GOLD-map "\eD"      (key-binding [gold next]))
     (define-key GOLD-map "\e[H"     (key-binding [gold deletechar]))
     (define-key GOLD-map "\e[24;1H" (key-binding [gold select]))
     (define-key GOLD-map ""       (key-binding [kp-period]))
    )
    ((or (string-match "^pc-6" REMOTEHOST)
         (string-match "^pc-7" REMOTEHOST))
     (define-key global-map [find]         (key-binding [help]))
     (define-key GOLD-map   [find]         (key-binding [gold help]))
;    (define-key global-map [kp-separator] (key-binding [f17]))
;    (define-key GOLD-map   [kp-separator] (key-binding [gold f17]))
    )
))

;;----------------------------------------------------------------------------
;; Some extra language-dependent-keys (may be missing on some keyboards) !
(defun adiaresis  () (interactive) (insert ?ä))
(defun Adiaresis  () (interactive) (insert ?Ä))
(defun anchor     () (interactive) (insert ?^))
(defun at         () (interactive) (insert ?@))
(defun bar        () (interactive) (insert ?|))
(defun cent       () (interactive) (insert ?¢))
(defun copyright  () (interactive) (insert ?©))
(defun degree     () (interactive) (insert ?°))
(defun dollar     () (interactive) (insert ?$))
(defun euro       () (interactive) (insert ?¤))
(defun paragraph  () (interactive) (insert ?§))
(defun odiaresis  () (interactive) (insert ?ö))
(defun Odiaresis  () (interactive) (insert ?Ö))
(defun pipe       () (interactive) (insert ?|))
(defun plusminus  () (interactive) (insert ?±))
(defun pound      () (interactive) (insert ?£))
(defun tilde      () (interactive) (insert ?~))
(defun registered () (interactive) (insert ?®))
(defun sharps     () (interactive) (insert ?ß))
(defun udiaresis  () (interactive) (insert ?ü))
(defun Udiaresis  () (interactive) (insert ?Ü))
(defun yen        () (interactive) (insert ?¥))
(defun backslash  () (interactive) (insert ?\\))
;;
(defalias 'ascii-table 'ASCII-table)
(defun ASCII-table () "Show a table with ASCII-Characters."
  (interactive)
  (unconditional-new-buffer "*ASCII-Table*" t)
  (insert "
     ASCII-Test table for ISO-Latin-1/9/15 (e.g. ECMA-94 ISO-8859-15):
  _____________________________________________________________________
 |                                                                     |
 |     ! \" # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = >     |
 |   ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \\ ] ^   |
 |   _ ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~   |
 |     ¡ ¢ £ ¤ ¥ ¦ § ¨ © ª « ¬ ­ ® ¯ ° ± ² ³ ´ µ ¶ · ¸ ¹ º » ¼ ½ ¾ ¿   |
 |   À Á Â Ã Ä Å Æ Ç È É Ê Ë Ì Í Î Ï Ð Ñ Ò Ó Ô Õ Ö × Ø Ù Ú Û Ü Ý Þ ß   |
 |   à á â ã ä å æ ç è é ê ë ì í î ï ð ñ ò ó ô õ ö ÷ ø ù ú û ü ý þ ÿ   |
 |_____________________________________________________________________|
"))

;;
(defalias 'utf8-boxchars 'UTF8-BoxChars)
(defun UTF8-BoxChars ()
"Show a table with UTF8-Characters for Box- and Line-Drawing."
  (interactive)
  (unconditional-new-buffer "*UTF8-BoxChars*" t)
  (insert "
╔══════════════════════════════════════════════════════════╗
║ UTF-8 Box drawing alignment tests (try different fonts): ║         █
╚══════════════════════════════════════════════════════════╝         ▉
  ╔══╦══╗  ┌──┬──┐  ╭──┬──╮  ╭──┬──╮  ┏━━┳━━┓  ┎┒┏┑   ╷  ╻ ┏┯┓ ┌┰┐   ▊ ╱╲╱╲╳╳╳
  ║┌─╨─┐║  │╔═╧═╗│  │╒═╪═╕│  │╓─╁─╖│  ┃┌─╂─┐┃  ┗╃╄┙  ╶┼╴╺╋╸┠┼┨ ┝╋┥   ▋ ╲╱╲╱╳╳╳
  ║│╲ ╱│║  │║   ║│  ││ │ ││  │║ ┃ ║│  ┃│ ╿ │┃  ┍╅╆┓   ╵  ╹ ┗┷┛ └┸┘   ▌ ╱╲╱╲╳╳╳
  ╠╡ ╳ ╞╣  ├╢   ╟┤  ├┼─┼─┼┤  ├╫─╂─╫┤  ┣┿╾┼╼┿┫  ┕┛┖┚     ┌┄┄┐ ╎ ┏┅┅┓ ┋ ▍ ╲╱╲╱╳╳╳
  ║│╱ ╲│║  │║   ║│  ││ │ ││  │║ ┃ ║│  ┃│ ╽ │┃  ░░▒▒▓▓██ ┊  ┆ ╎ ╏  ┇ ┋ ▎
  ║└─╥─┘║  │╚═╤═╝│  │╘═╪═╛│  │╙─╀─╜│  ┃└─╂─┘┃  ░░▒▒▓▓██ ┊  ┆ ╎ ╏  ┇ ┋ ▏
  ╚══╩══╝  └──┴──┘  ╰──┴──╯  ╰──┴──╯  ┗━━┻━━┛  ▗▄▖▛▀▜   └╌╌┘ ╎ ┗╍╍┛ ┋  ▁▂▃▄▅▆▇█
                                               ▝▀▘▙▄▟
"))

;;----------------------------------------------------------------------------
(provide 'gold_keyboard)
